package org.mortinious.fortress;

import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;

public class FortDetector {

	public FortDetector(int i, int j, int k, int m, int d, FortClaim c, FortMain main){
		
		x = i;
		y = j;
		z = k;
		mode = m;
		dir = d;
		claim = c;
		active = false;
		this.main = main;
	}
	
	public Boolean isTriggered(FortMain main, String s){
		for(int n = 0; n<main.getServer().getOnlinePlayers().length; n++){
			Player player = main.getServer().getOnlinePlayers()[n];
			if(isCoordOnDetector(player.getLocation().getBlockX(),player.getLocation().getBlockY(),player.getLocation().getBlockZ()) && !player.getName().equals(s)){
				return true;
			}
		}
		return false;
	}
	
	public Boolean isCoordOnDetector(int i, int j, int k){
		if((i==x)&&(j==y)&&(k==z)){
			return true;
		}
		return false;
	}
	
	public void activate(Player player){
		if(active == false){
			active = true;	
			if(main.getServer().getWorlds().get(0).getBlockAt(x, y-2, z).getType().equals(Material.REDSTONE_WIRE)){
			    main.getServer().getWorlds().get(0).getBlockAt(x, y-2, z).setType(Material.REDSTONE_TORCH_ON);
				System.out.println("Detector activated");
			}
		}
	}
	
	public void deactivate(){
		if(active == true){
		active = false;
			if(main.getServer().getWorlds().get(0).getBlockAt(x, y-2, z).getType().equals(Material.REDSTONE_TORCH_ON)){
				main.getServer().getWorlds().get(0).getBlockAt(x, y-2, z).setType(Material.REDSTONE_WIRE);
				System.out.println("Detector deactivated");
			}
		}
	}
	
	public void updateState(){
		if(active == true){
			main.getServer().getWorlds().get(0).getBlockAt(x, y-2, z).setType(Material.REDSTONE_TORCH_OFF);
		}
	}
	
    public static void setLever(Block lever, boolean down) {
        byte data = lever.getData();
        int newData;
        if (down) {
            newData = data | 0x8;
        } else {
            newData = data & 0x7;
        }
        if (newData != data) {
            lever.setData((byte) newData, true);
        }
    }
	
	public int x;
	public int y;
	public int z;
	public int mode;
	public int dir;
	public Boolean active;
	public FortClaim claim;
	public FortMain main;
}
